#include <iolpc2148.h>
#include "adc_dac.h"

#define   BIT30       0x20000000

void InitADC(void) {

  // 10 bits :-)

   // Select AD0.3
   AD0CR_bit.SEL = 0x08;

   // less than 4.5Mhz
   AD0CR_bit.CLKDIV = 14;

   // The A/D converter is operational.
   AD0CR_bit.PDN  = 1;

   // Set ADC function otn port P0.30
   PINSEL1_bit.P0_30 = 1;

}

void InitDAC(void) {

  // Set DAC function on port P0.25
  PINSEL1_bit.P0_25 = 2;

}

unsigned int GetADCValue(void) {

  // Select Chanel
  AD0DR_bit.CHN = 3;

  // Start conversion
  AD0CR_bit.START  = 1;

  // wait conversion
  while(!AD0DR_bit.DONE);

  // get value
  return AD0DR_bit.VVDDA;

}

void SetDACValue(unsigned int value) {

  // Set value
  DACR_bit.VALUE = value;

}

